/**
 * MapView Plugin
 * Version 1.12
 * Version Name: V112
 * Released Date: August 25, 2022
 * 
 * A Google Maps Plugin to integrate google maps into your DroidScript application.
 * 
 * Author: Jumar B. Hamac
 */
var __debug=!1,_ElevationForLocations=null,__mapCB={getBounds:function(){},getCenter:function(){},getClickableIcons:function(){},getHeading:function(){},getMapTypeId:function(){},getProjection:function(){},getTilt:function(){},getZoom:function(){},getStreetView:function(){}},__polygons=[],__polylines=[],_evLc=0,__markerCB=[],__infowindowCB=[],__circleCB=[],__polylineCB=[],__polygonCB=[],__rectangleCB=[],__heatmapCB=[],__markerClusterCB=[];app.CreateMapView=function(e,t,n,i,s,o,a,r){return new function(e,t,n,i,s,o,a,r){var l=null,c="object"==typeof i,u={center:{lat:c?i.lat:i,lng:c?i.lng:s},zoom:c?i.zoom:o||13,backgroundcolor:"#cfd8dc",disableDefaultUI:!0},p="",h="";c?(p=i.language,h=i.region):r&&(p=r.language,h=r.region);var d="";d=__debug?app.ReadFile("Map.js"):'\nvar map = null\n\nvar placesService = null\nvar directionsService = null\nvar elevationService = null\nvar dirRenderer = null\nvar trafficLayer = null\nvar transitLayer = null\nvar bicyclingLayer = null\n\nvar markers = []\nvar infowindows = []\nvar polylines = []\nvar polygons = []\nvar circles = []\nvar rectangles = []\nvar heatmaps = []\nvar markerClusters = []\n\nvar listeners = []\n\nfunction initDirectionsService() {\ndirectionsService = new google.maps.DirectionsService()\ndirectionsService.Route = function(request, callback, id) {\nthis.route(JSON.parse(request), function(results, status) {\nif(status === google.maps.places.PlacesServiceStatus.OK) {\nif(dirRenderer) {\ndirRenderer.setDirections(results)\n} else {\ndirRenderer = new google.maps.DirectionsRenderer({\ndirections: results,\nmap: map\n})\n}\nconsole.log(JSON.stringify(results))\napp.Execute(callback+"(\'"+JSON.stringify(results.geocoded_waypoints)+"\')")\n}\n})\n}\n}\n\nfunction ShowTraffic() {\nif(!trafficLayer) trafficLayer = new google.maps.TrafficLayer();\ntrafficLayer.setMap(map);\n}\nfunction ShowTransit() {\nif(!transitLayer) transitLayer = new google.maps.TransitLayer()\ntransitLayer.setMap(map);\n}\nfunction ShowBicycling() {\nif(!bicyclingLayer) bicyclingLayer = new google.maps.BicyclingLayer();\nbicyclingLayer.setMap(map);\n}\n\nfunction CreateMarker( o )\n{\nvar options = JSON.parse(o)\nvar marker = new google.maps.Marker(options)\nmarker.id = options.id\nmarker.AddEvent = function( e, cb, i )\n{\nvar id = this.id\nlisteners[i] = this.addListener(e, function( e = {} )\n{\ne.id = id\ne.type = "marker"\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')")\n})\n}\nmarker.SetOptions = function( o ) {\nthis.setOptions( JSON.parse( o ) )\n}\nmarker.SetIcon = function(o) {\nthis.setIcon(JSON.parse(o))\n}\nmarker.SetPosition = function(o) {\nthis.setPosition(JSON.parse(o))\n}\n\n// Getters\nmarker.GetClickable = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getClickable(" + ( this.getClickable() || false ) + ")" )\n}\nmarker.GetDraggable = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getDraggable(" + ( this.getDraggable() || false ) + ")" )\n}\nmarker.GetVisible = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getVisible(" + ( this.getVisible() || false ) + ")" )\n}\nmarker.GetZIndex = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getZIndex(" + this.getZIndex() + ")" )\n}\nmarker.GetTitle = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getTitle(\'" + this.getTitle() + "\')" )\n}\nmarker.GetLabel = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getLabel(\'" + JSON.stringify( this.getLabel() ) + "\')" )\n}\nmarker.GetAnimation = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getAnimation(\'" + ( this.getAnimation() || "None" ) + "\')" )\n}\nmarker.GetPosition = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getPosition(\'" + JSON.stringify( this.getPosition() ) + "\')" )\n}\nmarker.GetShape = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getShape(\'" + JSON.stringify( this.getShape() ) + "\')" )\n}\nmarker.GetCursor = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getCursor(\'" + this.getCursor() + "\')" )\n}\nmarker.GetIcon = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getIcon(\'" + JSON.stringify( this.getIcon() ) + "\')" )\n}\nmarker.GetOpacity = function()\n{\napp.Execute( "__markerCB[" + this.id + "].getOpacity(" + this.getOpacity() + ")" )\n}\nmarkers[options.id] = marker\n}\nfunction CreateInfoWindow( o )\n{\nvar options = JSON.parse( o )\noptions.content = options.content.replace(/_:_/gi, "=").replace(/_:/gi, \'"\').replace(/:_/gi, "\'")\nvar infoWindow = new google.maps.InfoWindow( options )\ninfoWindow.id = options.id\ninfoWindow.SetPosition = function(l) {\nthis.setPosition(JSON.parse(l))\n}\ninfoWindow.SetOptions = function(o) {\nthis.setOptions(JSON.parse(o))\n}\n// <String> id  The element id if the event listener is attached to the element\ninfoWindow.AddEvent = function(e, cb, i, elId) {\nvar id = this.id\nif( elId && document.getElementById( elId ) )\n{\ndocument.getElementById( elId )[ e + "_cb" ] = cb\ndocument.getElementById( elId )[ e ] = function( event )\n{\nvar cb = event.target[ "on" + event.type + "_cb" ]\napp.Execute( cb + "()" )\n}\n}\nelse\n{   \nlisteners[i] = this.addListener(e, function( e = {} )\n{\ne.id = id\ne.type = "info_window"\napp.Execute( cb + "(\'"+JSON.stringify(e)+"\')" )\n})\n}\n}\n\n// Getters\ninfoWindow.GetContent = function()\n{\napp.Execute( "__infowindowCB[" + this.id + "].getContent(\'" + this.getContent() + "\')" )\n}\ninfoWindow.GetPosition = function()\n{\napp.Execute( "__infowindowCB[" + this.id + "].getPosition(\'" + JSON.stringify( this.getPosition() ) + "\')" )\n}\ninfoWindow.GetZIndex = function()\n{\napp.Execute( "__infowindowCB[" + this.id + "].getZIndex(" + this.getZIndex() + ")" )\n}\ninfowindows[options.id] = infoWindow\n}\n\n// Drawing on the map\nfunction CreatePolyline( o )\n{\nvar options = JSON.parse( o )\nvar polyline = new google.maps.Polyline( options )\npolyline.id = options.id\npolyline.AddEvent = function( e, cb, i )\n{\nvar id = this.id\nlisteners[i] = this.addListener(e, function( e = {} )\n{\ne.id = id\ne.type = "polyline"\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')")\n})\n}\npolyline.SetOptions = function(o) {\nthis.setOptions(JSON.parse(o))\n}\npolyline.SetPath = function(path) {\nthis.setPath(JSON.parse(path))\n}\n\n// Getters\npolyline.GetDraggable = function()\n{\napp.Execute( "__polylineCB[" + this.id + "].getDraggable(" + ( this.getDraggable() || false ) + ")" )\n}\npolyline.GetEditable = function()\n{\napp.Execute( "__polylineCB[" + this.id + "].getEditable(" + ( this.getEditable() || false ) + ")" )\n}\npolyline.GetVisible = function()\n{\napp.Execute( "__polylineCB[" + this.id + "].getVisible(" + ( this.getVisible() || false ) + ")" )\n}\npolyline.GetPath = function()\n{\napp.Execute( "__polylineCB[" + this.id + "].getPath(\'" + JSON.stringify( this.getPath() ) + "\')" )\n}\n\nvar path = polyline.getPath()\npath.id = polyline.id\npath.addListener("set_at", __onEditPolyline)\npath.addListener("insert_at", __onEditPolyline)\npath.addListener("remove_at", __onEditPolyline)\n\npolylines[options.id] = polyline\n}\nfunction __onEditPolyline()\n{\nvar p = JSON.stringify( polylines[ this.id ].getPath().getArray() )\napp.Execute("__polygons["+this.id+"]._setPath(\'" + p + "\')")\n}\n\nfunction CreatePolygon( o )\n{\nvar options = JSON.parse(o)\nvar polygon = new google.maps.Polygon(options)\npolygon.id = options.id\npolygon.AddEvent = function(e, cb, i) {\nvar id = this.id\nlisteners[i] = this.addListener(e, function( e = {} ) {\ne.id = id\ne.type = "polygon"\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')")\n})\n}\npolygon.SetOptions = function(o) {\nthis.setOptions(JSON.parse(o))\n}\npolygon.SetPath = function(path) {\nthis.setPath(JSON.parse(path))\n}\npolygon.SetPaths = function(path) {\nthis.setPaths(JSON.parse(path))\n}\n\n// Getters\npolygon.GetDraggable = function()\n{\napp.Execute( "__polygonCB[" + this.id + "].getDraggable(" + ( this.getDraggable() || false ) + ")" )\n}\npolygon.GetEditable = function()\n{\napp.Execute( "__polygonCB[" + this.id + "].getEditable(" + ( this.getEditable() || false ) + ")" )\n}\npolygon.GetVisible = function()\n{\napp.Execute( "__polygonCB[" + this.id + "].getVisible(" + ( this.getVisible() || false ) + ")" )\n}\npolygon.GetPath = function()\n{\napp.Execute( "__polygonCB[" + this.id + "].getPath(\'" + JSON.stringify( this.getPath() ) + "\')" )\n}\npolygon.GetPaths = function()\n{\napp.Execute( "__polygonCB[" + this.id + "].getPaths(\'" + JSON.stringify( this.getPaths() ) + "\')" )\n}\n\nvar path = polygon.getPath()\npath.id = polygon.id\npath.addListener("set_at", __onEditPolygon)\npath.addListener("insert_at", __onEditPolygon)\npath.addListener("remove_at", __onEditPolygon)\n\npolygons[options.id] = polygon\n}\nfunction __onEditPolygon()\n{\nvar p = JSON.stringify( polygons[ this.id ].getPath().getArray() )\napp.Execute( "__polygons["+this.id+"]._setPath(\'" + p + "\')" )\n}\n\nfunction CreateCircle( o )\n{\nvar options = JSON.parse(o)\nvar circle = new google.maps.Circle(options)\ncircle.id = options.id\ncircle.AddEvent = function(e, cb, i) {\nvar id = this.id\nlisteners[i] = this.addListener(e, function( e = {} ) {\ne.id = id\ne.type = "circle"\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')")\n})\n}\ncircle.SetOptions = function(o) {\nthis.setOptions(JSON.parse(o))\n}\ncircle.SetCenter = function(o) {\nthis.setCenter(JSON.parse(o))\n}\n\n// Getters\ncircle.GetCenter = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getCenter(\'" + JSON.stringify( this.getCenter() ) + "\')"\n)\n}\ncircle.GetBounds = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getBounds(\'"+JSON.stringify(this.getBounds())+"\')"\n)\n}\ncircle.GetDraggable = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getDraggable("+ ( this.getDraggable() || false ) +")"\n)\n}\ncircle.GetEditable = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getEditable("+ ( this.getEditable() || false ) +")"\n)\n}\ncircle.GetVisible = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getVisible(" + this.getVisible() + ")"\n)\n}\ncircle.GetRadius = function()\n{\napp.Execute(\n"__circleCB["+this.id+"].getRadius(" + this.getRadius() + ")"\n)\n}\ncircles[options.id] = circle\n}\nfunction CreateRectangle( o )\n{\nvar options = JSON.parse(o)\nvar rectangle = new google.maps.Rectangle(options)\nrectangle.id = options.id\nrectangle.AddEvent = function(e, cb, i) {\nvar id = this.id\nlisteners[i] = this.addListener(e, function( e = {} ) {\ne.id = id\ne.type = "rectangle"\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')")\n})\n}\nrectangle.SetBounds = function() {\nthis.setBounds(JSON.parse(o))\n}\nrectangle.SetOptions = function(o) {\nthis.setOptions(JSON.parse(o))\n}\n\n//Getters\nrectangle.GetBounds = function()\n{\napp.Execute( "__rectangleCB[" + this.id + "].getBounds(\'" + JSON.stringify( this.getBounds() ) + "\')" )\n}\nrectangle.GetDraggable = function()\n{\napp.Execute( "__rectangleCB[" + this.id + "].getDraggable(" + ( this.getDraggable() || false ) + ")" )\n}\nrectangle.GetEditable = function()\n{\napp.Execute( "__rectangleCB[" + this.id + "].getEditable(" + ( this.getEditable() || false ) + ")" )\n}\nrectangle.GetVisible = function()\n{\napp.Execute( "__rectangleCB[" + this.id + "].getVisible(" + ( this.getVisible() || false ) + ")" )\n}\nrectangles[options.id] = rectangle\n}\n\n// Marker Clusterer\nfunction CreateMarkerCluster( markerIds, id )\n{\nvar ids = markerIds.split( "," )\nvar markersToCluster = ids.map( function( id )\n{\nreturn markers[ parseInt( id ) ]\n})\nvar cluster = new markerClusterer.MarkerClusterer(\n{\nmarkers: markersToCluster,\nid: id,\n// onClusterClick: function( e )\n// {\n//     e = e || {}\n//     app.Execute( "__markerClusterCB[" + this.id + "].setOnTouch(\'" + JSON.stringify( e ) + "\')" )\n// }\n})\ncluster.id = id\nmarkerClusters[ id ] = cluster\n}\n\nfunction RemoveMarker(id) {\nmarkers[id].setMap(null)\nmarkers[id] = null\n}\nfunction RemoveInfoWindow(id) {\ninfowindows[id].setMap(null)\ninfowindows[id] = null\n}\nfunction RemovePolyline(id) {\npolylines[id].setMap(null)\npolylines[id] = null\n}\nfunction RemovePolygon(id) {\npolygons[id].setMap(null)\npolygons[id] = null\n}\nfunction RemoveCircle(id) {\ncircles[id].setMap(null)\ncircles[id] = null\n}\nfunction RemoveRectangle(id) {\nrectangles[id].setMap(null)\nrectangles[id] = null\n}\n\n\nfunction removeAllMarkers() {\nmarkers.forEach(function(marker) {\nmarker.setMap(null)\n})\nmarkers = []\n}\nfunction removeAllInfowindows() {\ninfowindows.forEach(function(infowindow) {\ninfowindow.setMap(null)\n})\ninfowindows = []\n}\nfunction removeAllPolylines() {\npolylines.forEach(function(polyline) {\npolyline.setMap(null)\n})\npolylines = []\n}\nfunction removeAllPolygons() {\npolygons.forEach(function(polygon) {\npolygon.setMap(null)\n})\npolygons = []\n}\nfunction removeAllCircles() {\ncircles.forEach(function(circle) {\ncircle.setMap(null)\n})\ncircles = []\n}\nfunction removeAllRectangles() {\nrectangles.forEach(function(rectangle) {\nrectangle.setMap(null)\n})\nrectangles = []\n}\nfunction removeAll() {\nremoveAllMarkers()\nremoveAllInfowindows()\nremoveAllPolylines()\nremoveAllPolygons()\nremoveAllCircles()\nremoveAllRectangles()\nremoveAllHeatmaps()\ndirRenderer.setMap(null)\n}\n\nfunction CreateHeatMap( o )\n{\nvar options = JSON.parse( o )\nvar data = options.data.map( function( latLng )\n{\nreturn new google.maps.LatLng( latLng.lat, latLng.lng )\n})\noptions.data = data\nvar heatmap = new google.maps.visualization.HeatmapLayer( options )\n\nheatmap.SetData = function( o )\n{\nthis.setData( JSON.parse( o ) )\n}\nheatmap.SetGradient = function( g )\n{\nthis.set( \'gradient\', JSON.parse( g ) )\n}\n\n// Getters\nheatmap.GetData = function()\n{\napp.Execute( "__heatmapCB[" + this.id + "].getData(\'" + JSON.stringify( this.getData() ) + "\')" )\n}\nheatmaps[ options.id ] = heatmap\n}\nfunction removeAllHeatmaps() {\nheatmaps.forEach(function(heatmap) {\nheatmap.setMap(null)\n})\nheatmaps = []\n}\n\nfunction InitializeDarkMode() {\nvar style = [\n{elementType: \'geometry\', stylers: [{color: \'#242f3e\'}]},\n{elementType: \'labels.text.stroke\', stylers: [{color: \'#242f3e\'}]},\n{elementType: \'labels.text.fill\', stylers: [{color: \'#746855\'}]},\n{\nfeatureType: \'administrative.locality\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#d59563\'}]\n},\n{\nfeatureType: \'poi\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#d59563\'}]\n},\n{\nfeatureType: \'poi.park\',\nelementType: \'geometry\',\nstylers: [{color: \'#263c3f\'}]\n},\n{\nfeatureType: \'poi.park\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#6b9a76\'}]\n},\n{\nfeatureType: \'road\',\nelementType: \'geometry\',\nstylers: [{color: \'#38414e\'}]\n},\n{\nfeatureType: \'road\',\nelementType: \'geometry.stroke\',\nstylers: [{color: \'#212a37\'}]\n},\n{\nfeatureType: \'road\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#9ca5b3\'}]\n},\n{\nfeatureType: \'road.highway\',\nelementType: \'geometry\',\nstylers: [{color: \'#746855\'}]\n},\n{\nfeatureType: \'road.highway\',\nelementType: \'geometry.stroke\',\nstylers: [{color: \'#1f2835\'}]\n},\n{\nfeatureType: \'road.highway\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#f3d19c\'}]\n},\n{\nfeatureType: \'transit\',\nelementType: \'geometry\',\nstylers: [{color: \'#2f3948\'}]\n},\n{\nfeatureType: \'transit.station\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#d59563\'}]\n},\n{\nfeatureType: \'water\',\nelementType: \'geometry\',\nstylers: [{color: \'#17263c\'}]\n},\n{\nfeatureType: \'water\',\nelementType: \'labels.text.fill\',\nstylers: [{color: \'#515c6d\'}]\n},\n{\nfeatureType: \'water\',\nelementType: \'labels.text.stroke\',\nstylers: [{color: \'#17263c\'}]\n}\n]\nvar DarkMapType = new google.maps.StyledMapType(style, {name: \'Dark Map\'})\n//Associate the styled map with the MapTypeId and set it to display.\nmap.mapTypes.set(\'DARKMAP\', DarkMapType)\n}\n\nvar styles = {\ndefault: null,\nhide: [\n{\nfeatureType: "poi.business",\nstylers: [{ visibility: "off" }]\n},\n{\nfeatureType: "transit",\nelementType: "labels.icon",\nstylers: [{ visibility: "off" }]\n},\n{elementType: \'labels.text.stroke\', stylers: [{ visibility: "off" }]},\n{elementType: \'labels.text.fill\', stylers: [{ visibility: "off" }]},\n{\nfeatureType: \'administrative.locality\',\nelementType: \'labels.text.fill\',\nstylers: [{ visibility: "off" }]\n},\n{\nfeatureType: \'poi\',\nelementType: \'labels.text.fill\',\nstylers: [{ visibility: "off" }]\n},\n{\nfeatureType: \'poi.park\',\nelementType: \'geometry\',\nstylers: [{color: \'#263c3f\'}]\n},\n{\nfeatureType: \'poi.park\',\nstylers: [{ visibility: "off" }]\n},\n{\nfeatureType: \'transit.station\',\nstylers: [{ visibility: "off" }]\n}\n]\n}';var g='<!DOCTYPE html>\n<html>\n<head>\n<title>Simple Map</title>\n<script src="file:///android_asset/app.js"><\/script>\n<meta name="viewport" content="initial-scale=1.0">\n<meta charset="utf-8">\n<style>\n#map {\nheight: 100%;\nwidth: 100%;\n}\nhtml, body {\nheight: 100%;\nmargin: 0;\npadding: 0;\n}\n</style>\n</head>\n<body>\n<div id="map"></div>\n<script>'+d+'<\/script>\n<script>\nfunction initMap() {\nmap = new google.maps.Map(document.getElementById("map"), '+JSON.stringify(u)+');\nmap.AddEvent = function(e, cb, id) {\nlisteners[id] = this.addListener(e, function(e) {\napp.Execute(cb+"(\'"+JSON.stringify(e)+"\')");\n});\n}\nmap.SetCenter = function(latLng) {\nthis.setCenter(JSON.parse(latLng));\n}\nmap.PanTo = function(latLng) {\nthis.panTo(JSON.parse(latLng));\n}\nmap.SetOptions = function(opt) {\nthis.setOptions(JSON.parse(opt));\n}\nmap.FitBounds = function(o) {\nthis.fitBounds(JSON.parse(o));\n}\n\nmap.GetBounds = function()\n{\napp.Execute( "__mapCB.getBounds(\'" + JSON.stringify( this.getBounds() ) + "\')" )\n}\nmap.GetCenter = function()\n{\napp.Execute( "__mapCB.getCenter(\'" + JSON.stringify( this.getCenter() ) + "\')" )\n}\nmap.GetClickableIcons = function()\n{\napp.Execute( "__mapCB.getClickableIcons(" + this.getClickableIcons() + ")" )\n}\nmap.GetHeading = function()\n{\napp.Execute( "__mapCB.getHeading(" + this.getHeading() + ")" )\n}\nmap.GetMapTypeId = function()\n{\napp.Execute( "__mapCB.getMapTypeId(\'" + this.getMapTypeId() + "\')" )\n}\nmap.GetProjection = function()\n{\napp.Execute( "__mapCB.getProjection(\'" + JSON.stringify( this.getProjection() ) + "\')" )\n}\nmap.GetTilt = function()\n{\napp.Execute( "__mapCB.getTilt(" + this.getTilt() + ")" )\n}\nmap.GetZoom = function()\n{\napp.Execute( "__mapCB.getZoom(" + this.getZoom() + ")" )\n}\nmap.GetStreetView = function()\n{\napp.Execute( "__mapCB.getStreetView(\'" + JSON.stringify( this.getStreetView() )+ "\')" )\n}\n\n\nInitializeDarkMode();\n}\n<\/script>\n<script src="https://unpkg.com/@googlemaps/markerclusterer@1.0.21/dist/index.min.js"><\/script>\n<script src="https://maps.googleapis.com/maps/api/js?key='+e+"&libraries=places,visualization&region="+h+"&language="+p+'&callback=initMap&v=weekly" async defer><\/script>\n</body>\n</html>';t=t||1,n=n||1;var f=app.CreateWebView(t,n,"NoScrollbar,IgnoreErrors");return f.SetOnProgress(function(e){100===e&&l&&l()}),f.SetOnReady=function(e){l=e},f.LoadHtml(g),f.version=1.11,f.GetVersion=function(){return this.version},f.FitBounds=function(e,t,n,i){this.Execute("map.FitBounds('"+JSON.stringify({north:e,south:t,east:n,west:i})+"')")},f.GetBounds=function(e){__mapCB.getBounds=e,this.Execute("map.GetBounds()")},f.GetCenter=function(e){__mapCB.getCenter=e,this.Execute("map.GetCenter()")},f.GetClickableIcons=function(e){__mapCB.getClickableIcons=e,this.Execute("map.GetClickableIcons()")},f.GetHeading=function(e){__mapCB.getHeading=e,this.Execute("map.GetHeading()")},f.GetMapTypeId=function(e){__mapCB.getMapTypeId=e,this.Execute("map.GetMapTypeId()")},f.GetProjection=function(e){__mapCB.getProjection=e,this.Execute("map.GetProjection()")},f.GetStreetView=function(e){__mapCB.getStreetView=e,this.Execute("map.GetStreetView()")},f.GetTilt=function(e){__mapCB.getTilt=e,this.Execute("map.GetTilt()")},f.GetZoom=function(e){__mapCB.getZoom=e,this.Execute("map.GetZoom()")},f.PanBy=function(e,t){this.Execute("map.panBy("+e+", "+t+")")},f.PanTo=function(e,t){this.Execute("map.PanTo('"+JSON.stringify({lat:e,lng:t})+"')")},f.SetCenter=function(e,t){this.Execute("map.SetCenter('"+JSON.stringify({lat:e,lng:t})+"')")},f.SetClickableIcons=function(e){this.Execute("map.setClickableIcons("+e+")")},f.SetHeading=function(e){this.Execute("map.setHeading("+e+")")},f.SetMapTypeId=function(e){"darkmap"==e.toLowerCase()?this.Execute("map.setMapTypeId('"+e+"')"):this.Execute("map.setMapTypeId(google.maps.MapTypeId."+e+")")},f.SetOptions=function(e){this.Execute("map.SetOptions('"+JSON.stringify(e)+"')")},f.SetStreetView=function(){},f.SetTilt=function(e){0!==e&&45!=e||this.Execute("map.setTilt("+e+")")},f.SetZoom=function(e){this.Execute("map.setZoom("+e+")")},f.SetStyle=function(e){e=e.toLowerCase(),this.Execute("map.setOptions({ styles: styles['"+e+"'] })")},f.APIKey=e,f.type="map",f.AddListener=function(e,t){this.Execute("map.AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"map"};return _evLc++,n},f.RemoveListener=function(e){this.Execute("google.maps.event.removeListener(listeners["+e.id+"])")},f.ClearAllListeners=function(e){var t;"map"!=e.type?("marker"==e.type?t="markers":"info_window"==e.type?t="infowindows":"polyline"==e.type?t="polylines":"polygon"==e.type?t="polygon":"rectangle"==e.type?t="rectangles":"circle"==e.type&&(t="circles"),this.Execute("google.maps.event.clearInstanceListeners("+t+"["+e.id+"])")):this.Execute("google.maps.event.clearInstanceListeners(map)")},f.ClearListeners=function(e,t){var n;"map"!=e.type?("marker"==e.type?n="markers":"info_window"==e.type?n="infowindows":"polyline"==e.type?n="polylines":"polygon"==e.type?n="polygon":"rectangle"==e.type?n="rectangles":"circle"==e.type&&(n="circles"),this.Execute("google.maps.event.clearListeners("+n+"["+e.id+"], '"+t+"')")):this.Execute("google.maps.event.clearInstanceListeners(map, '"+t+"')")},f.markersCount=0,f.infoWindowsCount=0,f.polylinesCount=0,f.polygonsCount=0,f.circlesCount=0,f.rectanglesCount=0,f.placesServiceCount=0,f.heatmapsCount=0,f.markerClustersCount=0,f.CreateMarker=function(e,t,n){if(!e||!t)return null;var i=this.markersCount;return this.markersCount++,new function(e,t,n,i,s){this.options={position:{lat:t,lng:n},id:s},this.type="marker",this.id=s,this.Execute=e,i="boolean"!=typeof i||i,this.Show=function(){this.Execute("markers["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("markers["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("markers["+this.id+"] = null")},this.Execute("CreateMarker('"+JSON.stringify(this.options)+"')"),i&&this.Show(),this.GetClickable=function(e){__markerCB[this.id].getClickable=e,this.Execute("markers["+this.id+"].GetClickable()")},this.GetDraggable=function(e){__markerCB[this.id].getDraggable=e,this.Execute("markers["+this.id+"].GetDraggable()")},this.GetVisible=function(e){__markerCB[this.id].getVisible=e,this.Execute("markers["+this.id+"].GetVisible()")},this.GetZIndex=function(e){__markerCB[this.id].getZIndex=e,this.Execute("markers["+this.id+"].GetZIndex()")},this.GetTitle=function(e){__markerCB[this.id].getTitle=e,this.Execute("markers["+this.id+"].GetTitle()")},this.GetLabel=function(e){__markerCB[this.id].getLabel=e,this.Execute("markers["+this.id+"].GetLabel()")},this.GetOpacity=function(e){__markerCB[this.id].getOpacity=e,this.Execute("markers["+this.id+"].GetOpacity()")},this.GetAnimation=function(e){__markerCB[this.id].getAnimation=e,this.Execute("markers["+this.id+"].GetAnimation()")},this.GetPosition=function(e){__markerCB[this.id].getPosition=e,this.Execute("markers["+this.id+"].GetPosition()")},this.GetShape=function(e){__markerCB[this.id].getShape=e,this.Execute("markers["+this.id+"].GetShape()")},this.GetCursor=function(e){__markerCB[this.id].getCursor=e,this.Execute("markers["+this.id+"].GetCursor()")},this.GetIcon=function(e){__markerCB[this.id].getIcon=e,this.Execute("markers["+this.id+"].getIcon()")},this.SetAnimation=function(e){this.Execute("markers["+this.id+"].setAnimation(google.maps.Animation."+e.toUpperCase()+")")},this.SetClickable=function(e){this.Execute("markers["+this.id+"].setClickable("+e+")")},this.SetDraggable=function(e){this.Execute("markers["+this.id+"].setDraggable("+e+")")},this.SetIcon=function(e,t,n,i){var s={url:t?"https://www.google.com/intl/en_us/mapfiles/ms/micons/"+t+"-dot.png":e,scaledSize:t?null:{width:n||40,height:i||40}};this.Execute("markers["+this.id+"].SetIcon('"+JSON.stringify(s)+"')")},this.SetLabel=function(e){this.Execute("markers["+this.id+"].setLabel('"+e+"')")},this.SetOpacity=function(e){this.Execute("markers["+this.id+"].setOpacity("+e+")")},this.SetOptions=function(e){this.Execute("markers["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetPosition=function(e,t){this.Execute("markers["+this.id+"].SetPosition('"+JSON.stringify({lat:e,lng:t})+"')")},this.SetTitle=function(e){this.Execute("markers["+this.id+"].setTitle('"+e+"')")},this.SetVisible=function(e){this.Execute("markers["+this.id+"].setVisible("+e+")")},this.SetZIndex=function(e){this.Execute("markers["+this.id+"].setZIndex("+e+")")},this.AddListener=function(e,t){if("string"==typeof t){this.Execute("markers["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"marker"};return _evLc++,n}},__markerCB[this.id]={getClickable:function(){},getDraggable:function(){},getVisible:function(){},getZIndex:function(){},getTitle:function(){},getLabel:function(){},getOpacity:function(){},getAnimation:function(){},getPosition:function(){},getShape:function(){},getCursor:function(){},getIcon:function(){}},this.getMap=function(){},this.setCursor=function(){},this.setShape=function(){},this.setMap=function(){}}(this.Execute,e,t,n,i)},f.CreateInfoWindow=function(e,t,n,i){var s=this.infoWindowsCount;return this.infoWindowsCount++,new function(e,t,n,i,s,o){t&&(t=t.replace(/=/gi,"_:_").replace(/"/gi,"_:").replace(/'/gi,":_")),this.options={position:{lat:n,lng:i},content:t||"",id:o},this.type="info_window",this.id=o,this.Execute=e,s="boolean"==typeof s&&s,this.Open=function(e){(e=e||{})&&"string"==typeof e&&(e=JSON.parse(e));var t="marker"==e.type?"infowindows["+this.id+"].open(map, markers["+e.id+"])":"infowindows["+this.id+"].open(map)";this.Execute(t)},this.Close=function(){this.Execute("infowindows["+this.id+"].close()")},this.Remove=function(){this.Close(),this.Execute("markers["+this.id+"] = null")},this.Execute("CreateInfoWindow('"+JSON.stringify(this.options)+"')"),s&&this.Open(),this.GetContent=function(e){__infowindowCB[this.id].getContent=e,this.Execute("infowindows["+this.id+"].GetContent()")},this.GetPosition=function(e){__infowindowCB[this.id].getPosition=e,this.Execute("infowindows["+this.id+"].GetPosition()")},this.GetZIndex=function(e){__infowindowCB[this.id].getZIndex=e,this.Execute("infowindows["+this.id+"].GetZIndex()")},this.SetContent=function(e){this.Execute("infowindows["+this.id+"].setContent('"+e+"')")},this.SetOptions=function(e){this.Execute("infowindows["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetPosition=function(e,t){this.Execute("infowindows["+this.id+"].SetPosition('"+JSON.stringify({lat:e,lng:t})+"')")},this.SetZIndex=function(e){this.Execute("infowindows["+this.id+"].setZIndex("+e+")")},this.AddListener=function(e,t,n){"function"==typeof t&&(t=t.name+""),n?this.Execute("infowindows["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+", '"+n+"')"):this.Execute("infowindows["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var i={type:"event_listener",id:_evLc,event:e,el:n,object:"info_window"};return _evLc++,i},__infowindowCB[this.id]={getContent:function(){},getPosition:function(){},getZIndex:function(){}}}(this.Execute,e,t,n,i,s)},f.CreatePolyline=function(e,t,n,i,s){var o=this.polylinesCount;return this.polylinesCount++,new function(e,t,n,i,s,o,a){this.id=a,this.Execute=e,this.options={path:t,strokeWeight:n||4,strokeColor:i||"",strokeOpacity:s||1,id:a},this.type="polyline",this.path=t,this._setPath=function(e){this.path=JSON.parse(e)},o="boolean"!=typeof o||o,this.Show=function(){this.Execute("polylines["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("polylines["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("polylines["+this.id+"] = null")},this.Execute("CreatePolyline('"+JSON.stringify(this.options)+"')"),o&&this.Show(),this.GetDraggable=function(e){__polylineCB[this.id].getDraggable=e,this.Execute("polylines["+this.id+"].GetDraggable()")},this.GetEditable=function(e){__polylineCB[this.id].getEditable=e,this.Execute("polylines["+this.id+"].GetEditable()")},this.GetVisible=function(e){__polylineCB[this.id].getVisible=e,this.Execute("polylines["+this.id+"].GetVisible()")},this.GetPath=function(e){return e?(__polylineCB[this.id].getPath=e,this.path):this.path},this.SetDraggable=function(e){this.Execute("polylines["+this.id+"].setDraggable("+e+")")},this.SetEditable=function(e){this.Execute("polylines["+this.id+"].setEditable("+e+")")},this.SetOptions=function(e){this.Execute("polylines["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetPath=function(e){this.Execute("polylines["+this.id+"].SetPath('"+JSON.stringify(e)+"')")},this.SetVisible=function(e){this.Execute("polylines["+this.id+"].setVisible("+e+")")},this.AddListener=function(e,t){if("string"==typeof t){this.Execute("polylines["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"polyline"};return _evLc++,n}},__polylineCB[this.id]={getDraggable:function(){},getEditable:function(){},getVisible:function(){},getPath:function(){}},this.SetMap=function(){},__polylines[this.id]=this}(this.Execute,e,t,n,i,s,o)},f.CreatePolygon=function(e,t,n,i,s,o){var a=this.polygonsCount;return this.polygonsCount++,new function(e,t,n,i,s,o,a,r){this.id=r,this.Execute=e,this.options={path:t,fillColor:n||"",fillOpacity:i||.25,strokeWeight:s||4,strokeColor:o||"",id:r},this.type="polygon",this.path=t,this._setPath=function(e){this.path=JSON.parse(e)},a="boolean"!=typeof a||a,this.Show=function(){this.Execute("polygons["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("polygons["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("polygons["+this.id+"] = null")},this.Execute("CreatePolygon('"+JSON.stringify(this.options)+"')"),a&&this.Show(),this.GetDraggable=function(e){__polygonCB[this.id].getDraggable=e,this.Execute("polygons["+this.id+"].GetDraggable()")},this.GetEditable=function(e){__polygonCB[this.id].getEditable=e,this.Execute("polygons["+this.id+"].GetEditable()")},this.GetVisible=function(e){__polygonCB[this.id].getVisible=e,this.Execute("polygons["+this.id+"].GetVisible()")},this.GetPath=function(e){if(!e)return this.path;__polygonCB[this.id].getPath=e,e(this.path)},this.GetPaths=function(e){__polygonCB[this.id].getPaths=e,this.Execute("polygons["+this.id+"].GetPaths()")},this.SetDraggable=function(e){this.Execute("polygons["+this.id+"].setDraggable("+e+")")},this.SetEditable=function(e){this.Execute("polygons["+this.id+"].setEditable("+e+")")},this.SetOptions=function(e){this.Execute("polygons["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetPath=function(e){this.Execute("polygons["+this.id+"].SetPath('"+JSON.stringify(e)+"')")},this.SetPaths=function(e){this.Execute("polygons["+this.id+"].SetPaths('"+JSON.stringify(e)+"')")},this.SetVisible=function(e){this.Execute("polygons["+this.id+"].setVisible("+e+")")},this.AddListener=function(e,t){if("string"==typeof t){this.Execute("polygons["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"polygon"};return _evLc++,n}},__polygonCB[this.id]={getDraggable:function(){},getEditable:function(){},getVisible:function(){},getPath:function(){},getPaths:function(){}},__polygons[this.id]=this}(this.Execute,e,t,n,i,s,o,a)},f.CreateCircle=function(e,t,n,i,s,o,a,r){var l=this.circlesCount;return this.circlesCount++,new function(e,t,n,i,s,o,a,r,l,c){this.id=c,this.Execute=e,this.options={center:{lat:t,lng:n},radius:i||500,fillColor:s||"#a5d6a7",fillOpacity:o||.25,strokeWeight:a||4,strokeColor:r||"#81c784",id:c},this.type="circle",l="boolean"!=typeof l||l,this.Show=function(){this.Execute("circles["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("circles["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("circles["+this.id+"] = null")},this.Execute("CreateCircle('"+JSON.stringify(this.options)+"')"),l&&this.Show(),this.GetBounds=function(e){__circleCB[this.id].getBounds=e,this.Execute("circles["+this.id+"].GetBounds()")},this.GetCenter=function(e){__circleCB[this.id].getCenter=e,this.Execute("circles["+this.id+"].GetCenter()")},this.GetDraggable=function(e){__circleCB[this.id].getDraggable=e,this.Execute("circles["+this.id+"].GetDraggable()")},this.GetEditable=function(e){__circleCB[this.id].getEditable=e,this.Execute("circles["+this.id+"].GetEditable()")},this.GetRadius=function(e){__circleCB[this.id].getRadius=e,this.Execute("circles["+this.id+"].GetRadius()")},this.GetVisible=function(e){__circleCB[this.id].getVisible=e,this.Execute("circles["+this.id+"].GetVisible()")},this.SetCenter=function(e,t){e&&t&&this.Execute("circles["+this.id+"].SetCenter('"+JSON.stringify({lat:e,lng:t})+"')")},this.SetDraggable=function(e){this.Execute("circles["+this.id+"].setDraggable("+e+")")},this.SetEditable=function(e){this.Execute("circles["+this.id+"].setEditable("+e+")")},this.SetOptions=function(e){this.Execute("circles["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetRadius=function(e){this.Execute("circles["+this.id+"].setRadius("+e+")")},this.SetVisible=function(e){this.Execute("circles["+this.id+"].setVisible("+e+")")},this.AddListener=function(e,t){if("string"==typeof t){this.Execute("circles["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"circle"};return _evLc++,n}},__circleCB[this.id]={getCenter:function(){},getBounds:function(){},getDraggable:function(){},getEditable:function(){},getVisible:function(){},getRadius:function(){}}}(this.Execute,e,t,n,i,s,o,a,r,l)},f.CreateRectangle=function(e,t,n,i,s,o){var a=this.rectanglesCount;return this.rectanglesCount++,new function(e,t,n,i,s,o,a,r,l){this.id=l,this.Execute=e,this.options={bounds:t,fillColor:i||"#a5d6a7",fillOpacity:s||.25,strokeColor:a||"#81c784",strokeWeight:o||4,id:l},this.options.id=this.id,this.type="rectangle",r="boolean"!=typeof r||r,this.Show=function(){this.Execute("rectangles["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("rectangles["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("rectangles["+this.id+"] = null")},this.Execute("CreateRectangle('"+JSON.stringify(this.options)+"')"),r&&this.Show(),this.GetBounds=function(e){__rectangleCB[this.id].getBounds=e,this.Execute("rectangles["+this.id+"].GetBounds()")},this.GetDraggable=function(e){__rectangleCB[this.id].getDraggable=e,this.Execute("rectangles["+this.id+"].GetDraggable()")},this.GetEditable=function(e){__rectangleCB[this.id].getEditable=e,this.Execute("rectangles["+this.id+"].GetEditable()")},this.GetVisible=function(e){__rectangleCB[this.id].getVisible=e,this.Execute("rectangles["+this.id+"].GetVisible()")},this.SetBounds=function(e,t,n,i){e&&t&&n&&i&&this.Execute("rectangles["+this.id+"].SetBounds('"+JSON.stringify({north:e,south:t,east:n,west:i})+"')")},this.SetDraggable=function(e){this.Execute("rectangles["+this.id+"].setDraggable("+e+")")},this.SetEditable=function(e){this.Execute("rectangles["+this.id+"].setEditable("+e+")")},this.SetOptions=function(e){this.Execute("rectangles["+this.id+"].SetOptions('"+JSON.stringify(e)+"')")},this.SetVisible=function(e){this.Execute("rectangles["+this.id+"].setVisible("+e+")")},this.AddListener=function(e,t){if("string"==typeof t){this.Execute("rectangles["+this.id+"].AddEvent('"+e+"', '"+t+"', "+_evLc+")");var n={type:"event_listener",id:_evLc,event:e,object:"rectangle"};return _evLc++,n}},__rectangleCB[this.id]={getBounds:function(){},getDraggable:function(){},getEditable:function(){},getVisible:function(){}}}(this.Execute,e,t,n,i,s,o,a)},f.CreateLocator=function(e,t){if(e)return new function(e,t,n){var i=e,s=t,o=app.CreateLocator("GPS,Network");o.SetRate(n||10),o.SetOnChange(function(e){i("map.PanTo('"+JSON.stringify({lat:e.latitude,lng:e.longitude})+"')"),s(e)}),this.Stop=o.Stop,this.GetDistanceTo=o.GetDistanceTo,this.GetBearingTo=o.GetBearingTo,this.Start=o.Start}(this.Execute,e,t)},f.CreateHeatmap=function(e,t,n,i){if(!e)return null;var s=this.heatmapsCount;return this.heatmapsCount++,new function(e,t,n,i,s,o){this.id=o,this.Execute=e,this.options={data:t,radius:n,gradient:i,id:o},this.type="heatmap",s="boolean"!=typeof s||s,this.Show=function(){this.Execute("heatmaps["+this.id+"].setMap(map)")},this.Hide=function(){this.Execute("heatmaps["+this.id+"].setMap(null)")},this.Remove=function(){this.Hide(),this.Execute("heatmaps["+this.id+"] = null")},this.Execute("CreateHeatMap('"+JSON.stringify(this.options)+"')"),s&&this.Show(),this.SetData=function(e){this.Execute("heatmaps["+this.id+"].SetData('"+JSON.stringify(e)+"')")},this.SetRadius=function(e){this.Execute("heatmaps["+this.id+"].set('radius', "+e+")")},this.SetOpacity=function(e){this.Execute("heatmaps["+this.id+"].set('opacity', "+e+")")},this.SetGradient=function(e){this.Execute("heatmaps["+this.id+"].SetGradient('"+JSON.stringify(e)+"')")},this.GetData=function(e){__heatmapCB[this.id].getData=e,this.Execute("heatmaps["+this.id+"].GetData()")},__heatmapCB[this.id]={getData:function(){}}}(this.Execute,e,t,n,i,s)},f.CreateMarkerCluster=function(e,t){if(e||"object"==typeof e){var n=this.markerClustersCount;return this.markerClustersCount++,new function(e,t,n,i){this.Execute=e,this.id=n,this.type="MarkerCluster",this.markers=t,i=i||!0,this.Show=function(){this.Execute("markerClusters["+this.id+"].setMap( map )")},this.Hide=function(){this.Execute("markerClusters["+this.id+"].setMap( null )")},this.Remove=function(){this.Hide(),this.Execute("markerClusters["+this.id+"] = null")};var s=t.map(function(e){return e.id});this.Execute('CreateMarkerCluster( "'+s.toString()+'", '+this.id+" )"),i&&this.Show(),this.SetOnTouch=function(e){__markerClusterCB[this.id].setOnTouch=e},__markerClusterCB[this.id]={setOnTouch:function(){}}}(this.Execute,e,n,t)}},f.RemoveMarker=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemoveMarker("+t+")")},f.RemoveInfoWindow=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemoveInfoWindow("+t+")")},f.RemovePolyline=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemovePolyline("+t+")")},f.RemovePolygon=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemovePolygon("+t+")")},f.RemoveCircle=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemoveCircle("+t+")")},f.RemoveRectangle=function(e){var t=("string"==typeof e?JSON.parse(e):e).id;this.Execute("RemoveRectangle("+t+")")},f.RemoveAllMarkers=function(){this.Execute("removeAllMarkers()")},f.RemoveAllInfowindows=function(){this.Execute("removeAllInfowindows()")},f.RemoveAllPolylines=function(){this.Execute("removeAllPolylines()")},f.RemoveAllPolygons=function(){this.Execute("removeAllPolygons()")},f.RemoveAllCircles=function(){this.Execute("removeAllCircles()")},f.RemoveAllRectangles=function(){this.Execute("removeAllRectangles()")},f.RemoveAllHeatmaps=function(){this.Execute("removeAllHeatmaps()")},f.RemoveAll=function(){this.Execute("removeAll()")},f.FindPlaceByPhoneNumber=function(e,t,n){if(e&&n){var i=n,s="input="+(e="%2B"+e)+"|inputtype=phonenumber|fields="+(t=(t=t||"name,geometry/location,place_id").replace(/ /gi,""))+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/place/findplacefromtext/json",null,s,function(e,t){if(e)i(!0,"REQUEST ERROR");else{var n=JSON.parse(t);"OK"==n.status?n.candidates.length>0?i(!1,n.candidates):i(!0,"NO RESULT FOUND"):i(!0,n.status)}})}},f.FindPlaceByTextQuery=function(e,t,n,i,s,o){if(e&&o){var a=o;s=(s=s||"name,geometry/location,place_id").replace(/ /gi,"");var r="input="+(e=e.replace(/ /gi,"%20"))+"|inputtype=textquery|fields="+s+"|locationbias=circle:"+(i=i||5e3)+"@"+t+","+n+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/place/findplacefromtext/json",null,r,function(e,t){if(e)a(!0,"REQUEST ERROR");else{var n=JSON.parse(t);"OK"==n.status?n.candidates.length>0?a(!1,n.candidates):a(!0,"NO RESULT FOUND"):a(!0,n.status)}})}},f.GetPlaceDetails=function(e,t,n){if(e&&n){var i=n;t&&""!=t||(t="formatted_address,geometry/location,name");var s="place_id="+e+"|fields="+(t=t.replace(/ /gi,""))+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/place/details/json",null,s,function(e,t){if(e)i(!0,"REQUEST ERROR");else{var n=JSON.parse(t);"OK"==n.status?i(!1,n.result):i(!0,n.status)}})}},f.QueryAutocomplete=function(e,t,n,i,s){if(e&&s){var o=s;t=t||"",n=n||"";var a="input="+(e=e.replace(/ /gi,"+"))+"|location="+t+","+n+"|radius="+i+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/place/queryautocomplete/json",null,a,function(e,t){if(e)o(!0,"REQUEST ERROR");else{var n=JSON.parse(t);"OK"==n.status?n.predictions.length>0?o(!1,n.predictions):o(!0,"NO RESULT FOUND"):o(!0,n.status)}})}},f.PlaceAutocomplete=function(e,t,n,i,s,o){if(e&&o){queryCallback=o,n=n||"",i=i||"";var a="input="+(e=e.replace(/ /gi,"+"))+"|type="+t+"|location="+n+","+i+"|radius="+s+"|strictbounds=true|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/place/autocomplete/json",null,a,function(e,t){if(e)queryCallback(!0,"REQUEST ERROR");else{var n=JSON.parse(t);"OK"==n.status?n.predictions.length>0?queryCallback(!1,n.predictions):queryCallback(!0,"NO RESULT FOUND"):queryCallback(!0,n.status)}})}},f.InitDirectionsService=function(){this.Execute("initDirectionsService()")},f.ShowRoute=function(e,t,n,i){if(e&&t){var s={origin:e,destination:t,travelMode:n||"WALKING"};this.Execute("directionsService.Route('"+JSON.stringify(s)+"', '"+i+"')")}},f.HideRoute=function(){this.Execute("dirRenderer.setMap(null)")},f.GetElevation=function(e,t,n){if(e&&t&&n){var i=n,s="locations="+e+","+t+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/elevation/json",null,s,function(e,t){if(e)i(!0,"ERROR");else{var n=JSON.parse(t);"OK"==n.status?i(!1,n.results[0].elevation,n.results[0].resolution):i(!0,n.status)}})}},f.GetDistanceMatrix=function(e,t,n,i,s){if(e&&t&&s){var o=s,a="units="+i+"|origins="+e.lat+","+e.lng+"|destinations="+t.lat+","+t.lng+"|mode="+n+"|key="+this.APIKey;app.HttpRequest("GET","https://maps.googleapis.com/maps/api/distancematrix/json",null,a,function(e,t){if(e)o(!0,"ERROR");else{var n=JSON.parse(t);"OK"==n.status?"OK"==n.rows[0].elements[0].status?o(!1,n.rows[0].elements[0].distance.value,n.rows[0].elements[0].duration.value):o(!0,n.rows[0].elements[0].status):o(!0,n.status)}})}},f.ShowTrafficLayer=function(){this.Execute("ShowTraffic()")},f.HideTrafficLayer=function(){this.Execute("trafficLayer.setMap(null)")},f.RemoveTrafficLayer=function(){this.Execute("trafficLayer.setMap(null)"),this.Execute("trafficLayer = null")},f.ShowTransitLayer=function(){this.Execute("ShowTransit()")},f.HideTransitLayer=function(){this.Execute("transitLayer.setMap(null)")},f.RemoveTransitLayer=function(){this.Execute("transitLayer.setMap(null)"),this.Execute("transitLayer = null")},f.ShowBicyclingLayer=function(){this.Execute("ShowBicycling()")},f.HideTransitLayer=function(){this.Execute("bicyclingLayer.setMap(null)")},f.RemoveTransitLayer=function(){this.Execute("bicyclingLayer.setMap(null)"),this.Execute("bicyclingLayer = null")},f}(e,t,n,i,s,o,a,r)};






